# Generated by the protocol buffer compiler.  DO NOT EDIT!
# sources: services/event/v1/event.proto
# plugin: python-betterproto
from dataclasses import dataclass

import betterproto
from betterproto.grpc.grpclib_server import ServiceBase


class EventType(betterproto.Enum):
    PING = 0
    LOG = 1
    EGF_CREATED = 5
    EGF_MEMBER_REGISTERED = 6
    EGF_MEMBER_UNREGISTERED = 7
    TEMPLATE_CREATED = 10
    TEMPLATE_DELETED = 11
    WALLET_CREATED = 15
    ITEM_RECEIVED = 16


@dataclass(eq=False, repr=False)
class Event(betterproto.Message):
    """System event"""

    id: str = betterproto.string_field(1)
    """UUID for the event"""

    type: "EventType" = betterproto.enum_field(2)
    """event type"""

    timestamp: str = betterproto.string_field(3)
    """when the event occured"""

    data: bytes = betterproto.bytes_field(4)
    """data payload - will be encoded proto message for the event type"""


@dataclass(eq=False, repr=False)
class ApiCall(betterproto.Message):
    source: str = betterproto.string_field(1)
    request: bytes = betterproto.bytes_field(2)
    response: bytes = betterproto.bytes_field(3)


@dataclass(eq=False, repr=False)
class Ping(betterproto.Message):
    """Message to test webhook functionality"""

    id: str = betterproto.string_field(1)
    """UUID of this ping"""

    webhook_id: str = betterproto.string_field(2)
    """UUID of the webhook receiving the ping"""

    timestamp: str = betterproto.string_field(3)
    """when this was generated"""

    message: str = betterproto.string_field(4)
    """message to be sent (e.g. I'm a teapot)"""


@dataclass(eq=False, repr=False)
class EgfCreated(betterproto.Message):
    id: str = betterproto.string_field(1)
    """UUID of the governance framework"""

    ecosystem_id: str = betterproto.string_field(2)
    """UUID of the ecosystem that owns this egf"""

    trust_registry: str = betterproto.string_field(3)
    """Trust registry assoicated with this egf"""

    governing_authority: str = betterproto.string_field(4)
    """Wallet ID of the aurhority for this egf"""

    type: str = betterproto.string_field(5)
    """Type of egf"""

    name: str = betterproto.string_field(6)
    """User friendly name for the egf"""

    description: str = betterproto.string_field(7)
    """Description of the egf"""

    governance_framework: str = betterproto.string_field(8)
    """URI for the egf"""


@dataclass(eq=False, repr=False)
class TemplateCreated(betterproto.Message):
    id: str = betterproto.string_field(1)
    """UUID of the template"""

    ecosystem_id: str = betterproto.string_field(2)
    """UUID of the ecosystem that owns this template"""

    name: str = betterproto.string_field(3)
    """Template name"""

    type: str = betterproto.string_field(4)
    """Tempalte type"""

    created_by: str = betterproto.string_field(5)
    """WalletID that created the template"""


@dataclass(eq=False, repr=False)
class ItemReceived(betterproto.Message):
    id: str = betterproto.string_field(1)
    """UUID of the new item"""

    received: str = betterproto.string_field(2)
    """Timestamp when the item was received"""
